---
title: USBDevice.opened
slug: Web/API/USBDevice/opened
tags:
  - API
  - Property
  - Reference
  - USB
  - USBDevice
  - WebUSB
  - WebUSB API
  - opened
---
<p>{{SeeCompatTable}}{{APIRef("WebUSB API")}}</p>

<p>The <strong><code>opened</code></strong> read only property of the {{domxref("USBDevice")}} interface indicates whether a session has been started with a paired USB device. A device must be opened before it can be controlled by a web page.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var serialNumber = USBDevice.opened</pre>

<h3 id="Value">Value</h3>

<p>A {{jsxref("boolean")}}.</p>

<h2 id="Example">Example</h2>

<p>This example is for a hypothetical USB device with a multi-colored LED. It shows how to test that a device is open before calling {{domxref("USBDevice.controlTransferOut")}} to set a specified LED color.</p>

<div class="note">
<p>What data can be passed to a USB device and how it is passed is particular and unique to each device. </p>
</div>

<pre class="brush: js">async setDeviceColor(usbDevice, r, g, b) {
   if (device.opened) {
     // This hypothetical USB device requires that the data passed to
     // it be in a Uint8Array.
     let payload = new Uint8Array([r, g, b]);

     await usbDevice.controlTransferOut({
       requestType: 'vendor',
       recipient: 'device',
       request: 1,
       value: 0,
       index: 0,
     }, payload);
   }
 }
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web USB','#dom-usbdevice-opened','opened')}}</td>
   <td>{{Spec2('Web USB')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.USBDevice.opened")}}</p>
